;
;  D48 Test File
;
	ORG	0
;
;  0x group
;
START:	NOP		; 00
			; 01 unassigned
	OUTL	BUS,A	; 02
	ADD	A,#12H	; 03
	JMP	START	; 04
	EN	I	; 05
;			; 06 unassigned
	DEC	A	; 07
	INS	A,BUS	; 08
	IN	A,P1	; 09
	IN	A,P2	; 0A
;			; 0B unassigned
	MOVD	A,P4	; 0C
	MOVD	A,P5	; 0D
	MOVD	A,P6	; 0E
	MOVD	A,P7	; 0F
;
;  1x group
;
GRP1:	INC	@R0	; 10
	INC	@R1	; 11
	JB0	GRP1	; 12
	ADDC	A,#12	; 13
	CALL	GRP1	; 14
	DIS	I	; 15
	JTF	GRP1	; 16
	INC	A	; 17
	INC	R0	; 18
	INC	R1	; 19
	INC	R2	; 1A
	INC	R3	; 1B
	INC	R4	; 1C
	INC	R5	; 1D
	INC	R6	; 1E
	INC	R7	; 1F
;
;  2x group
;
GRP2	XCH	A,@R0	; 20
	XCH	A,@R1	; 21
;			; 22 unassigned
	MOV	A,#12H	; 23
	JMP	PAG1	; 24
	EN	T	; 25
	JNT0	GRP2	; 26
	CLR	A	; 27
	XCH	A,R0	; 28
	XCH	A,R1	; 29
	XCH	A,R2	; 2A
	XCH	A,R3	; 2B
	XCH	A,R4	; 2C
	XCH	A,R5	; 2D
	XCH	A,R6	; 2E
	XCH	A,R7	; 2F
;
;  3x group
;
GRP3:	XCHD	A,@R0	; 30
	XCHD	A,@R1	; 31
	JB1	GRP3	; 32
;			; 33 unassigned
	CALL	PAG1	; 34
	DIS	T	; 35
	JT0	GRP3	; 36
	CPL	A	; 37
;			; 38 unassigned
	OUTL	P1,A	; 39
	OUTL	P2,A	; 3A
;			; 3B unassigned
	MOVD	P4,A	; 3C
	MOVD	P5,A	; 3D
	MOVD	P6,A	; 3E
	MOVD	P7,A	; 3F
;
;  4x group
;
GRP4:	ORL	A,@R0	; 40
	ORL	A,@R1	; 41
	MOV	A,T	; 42
	ORL	A,#12	; 43
	JMP	PAG2	; 44
	STRT	C	; 45
	JNT1	GRP4	; 46
	SWAP	A	; 47
	ORL	A,R0	; 48
	ORL	A,R1	; 49
	ORL	A,R2	; 4A
	ORL	A,R3	; 4B
	ORL	A,R4	; 4C
	ORL	A,R5	; 4D
	ORL	A,R6	; 4E
	ORL	A,R7	; 4F
;
;  5x group
;
GRP5:	ANL	A,@R0	; 50
	ANL	A,@R1	; 51
	JB2	GRP5	; 52
	ANL	A,#12H	; 53
	CALL	PAG2	; 54
	STRT	T	; 55
	JT1	GRP5	; 56
	DA	A	; 57
	ANL	A,R0	; 58
	ANL	A,R1	; 59
	ANL	A,R2	; 5A
	ANL	A,R3	; 5B
	ANL	A,R4	; 5C
	ANL	A,R5	; 5D
	ANL	A,R6	; 5E
	ANL	A,R7	; 5F
;
;  6x group
;
	ADD	A,@R0	; 60
	ADD	A,@R1	; 61
	MOV	T,A	; 62
;			; 63 unassigned
	JMP	PAG3	; 64
	STOP	T	; 65
;			; 66 unassigned
	RRC	A	; 67
	ADD	A,R0	; 68
	ADD	A,R1	; 69
	ADD	A,R2	; 6A
	ADD	A,R3	; 6B
	ADD	A,R4	; 6C
	ADD	A,R5	; 6D
	ADD	A,R6	; 6E
	ADD	A,R7	; 6F
;
;  7x group
;
GRP7:	ADDC	A,@R0	; 70
	ADDC	A,@R1	; 71
	JB3	GRP7	; 72
;			; 73 unassigned
	CALL	PAG3	; 74
	ENT0	CLK	; 75
	JF1	GRP7	; 76
	RR	A	; 77
	ADDC	A,R0	; 78
	ADDC	A,R1	; 79
	ADDC	A,R2	; 7A
	ADDC	A,R3	; 7B
	ADDC	A,R4	; 7C
	ADDC	A,R5	; 7D
	ADDC	A,R6	; 7E
	ADDC	A,R7	; 7F
;
;  8x group
;
GRP8:	MOVX	A,@R0	; 80
	MOVX	A,@R1	; 81
;			; 82 unassigned
	RET		; 83
	JMP	PAG4	; 84
	CLR	F0	; 85
	JNI	GRP8	; 86
;			; 87 unassigned
	ORL	BUS,#12	; 88
	ORL	P1,#12H	; 89
	ORL	P2,#12	; 8A
;			; 8B unassigned
	ORLD	P4,A	; 8C
	ORLD	P5,A	; 8D
	ORLD	P6,A	; 8E
	ORLD	P7,A	; 8F
;
;  9x group
;
GRP9	MOVX	@R0,A	; 90
	MOVX	@R1,A	; 91
	JB4	GRP9	; 92
	RETR		; 93
	CALL	PAG4	; 94
	CPL	F0	; 95
	JNZ	GRP9	; 96
	CLR	C	; 97
	ANL	BUS,#12	; 98
	ANL	P1,#12H	; 99
	ANL	P2,#12	; 9A
;			; 9B unassigned
	ANLD	P4,A	; 9C
	ANLD	P5,A	; 9D
	ANLD	P6,A	; 9E
	ANLD	P7,A	; 9F
;
;  Ax group
;
	MOV	@R0,A	; A0
	MOV	@R1,A	; A1
;			; A2 unassigned
	MOVP	A,@A	; A3
	JMP	PAG5	; A4
	CLR	F1	; A5
;			; A6 unassigned
	CPL	C	; A7
	MOV	R0,A	; A8
	MOV	R1,A	; A9
	MOV	R2,A	; AA
	MOV	R3,A	; AB
	MOV	R4,A	; AC
	MOV	R5,A	; AD
	MOV	R6,A	; AE
	MOV	R7,A	; AF
;
;  Bx group
;
GRPB:	MOV	@R0,#12	; B0
	MOV	@R1,#12	; B1
	JB5	GRPB	; B2
	JMPP		; B3
	CALL	PAG5	; B4
	CPL	F1	; B5
	JF0	GRPB	; B6
;			; B7 unassigned
	MOV	R0,#12	; B8
	MOV	R1,#12H	; B9
	MOV	R2,#12	; BA
	MOV	R3,#12H	; BB
	MOV	R4,#12	; BC
	MOV	R5,#12H	; BD
	MOV	R6,#12	; BE
	MOV	R7,#12H	; BF
;
;  Cx group
;
;			; C0 unassigned
;			; C1 unassigned
;			; C2 unassigned
;			; C3 unassigned
GRPC:	JMP	PAG6	; C4
	SEL	RB0	; C5
	JZ	GRPC	; C6
	MOV	A,PSW	; C7
	DEC	R0	; C8
	DEC	R1	; C9
	DEC	R2	; CA
	DEC	R3	; CB
	DEC	R4	; CC
	DEC	R5	; CD
	DEC	R6	; CE
	DEC	R7	; CF
;
;  Dx group
;
GRPD:	XRL	A,@R0	; D0
	XRL	A,@R1	; D1
	JB6	GRPD	; D2
	XRL	A,#12	; D3
	CALL	PAG6	; D4
	SEL	RB1	; D5
;			; D6 unassigned
	MOV	PSW,A	; D7
	XRL	A,R0	; D8
	XRL	A,R1	; D9
	XRL	A,R2	; DA
	XRL	A,R3	; DB
	XRL	A,R4	; DC
	XRL	A,R5	; DD
	XRL	A,R6	; DE
	XRL	A,R7	; DF
;
;  Ex group
;
	ORG	100H
;
;			; E0 unassigned
;			; E1 unassigned
;			; E2 unassigned
GRPE:	MOVP3	A,@A	; E3
	JMP	PAG7	; E4
	SEL	MB0	; E5
	JNC	GRPE	; E6
	RL	A	; E7
;
LOOP	DJNZ	R0,LOOP	; E8
	DJNZ	R1,LOOP	; E9
	DJNZ	R2,LOOP	; EA
	DJNZ	R3,LOOP	; EB
	DJNZ	R4,LOOP	; EC
	DJNZ	R5,LOOP	; ED
	DJNZ	R6,LOOP	; EE
	DJNZ	R7,LOOP	; EF
;
;  Fx group
;
GRPF:	MOV	A,@R0	; F0
	MOV	A,@R1	; F1
	JB7	GRPF	; F2
;			; F3 unassigned
	CALL	PAG7	; F4
	SEL	MB1	; F5
	JC	GRPF	; F6
	RLC	A	; F7
	MOV	A,R0	; F8
	MOV	A,R1	; F9
	MOV	A,R2	; FA
	MOV	A,R3	; FB
	MOV	A,R4	; FC
	MOV	A,R5	; FD
	MOV	A,R6	; FE
	MOV	A,R7	; FF
;
PAG1	EQU	123H
PAG2:	EQU	224H
PAG3	EQU	345H
PAG4:	EQU	456H
PAG5	EQU	567H
PAG6:	EQU	678H
PAG7	EQU	789H
;
        END
;
